/* Copyright (C) 2015 by ETH Zürich
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU GPL (v>=2)
 * and comes with ABSOLUTELY NO WARRANTY!
 * See LICENSE.txt for details.
 */
#include "includeemptysortmodel.h"

bool IncludeEmptySortModel::filterAcceptsRow(int row, const QModelIndex &parent) const
{
    bool parentAcceptsRow = QSortFilterProxyModel::filterAcceptsRow(row, parent);
    if (!mIncludeEmpty || parentAcceptsRow) {
        return parentAcceptsRow;
    }

    QModelIndex source_index = sourceModel()->index(row, filterKeyColumn(), parent);
    if (!source_index.isValid()) // the column may not exist
        return true;
    QString key = sourceModel()->data(source_index).toString();
    return key.isEmpty();
}
